require "rails/generators"
module Patriarch
  module Generators  
    class InstallGenerator < Rails::Generators::Base
      source_root File.expand_path('../templates', __FILE__)
      
      desc "Installs the gem"
    
      def init_directories
        copy_file "empty_behaviours_declaration.rb", "lib/patriarch/behaviours.rb"
      end
      
      def copy_compulsory_files
        copy_file "empty_behaviours_declaration.rb", "lib/patriarch/behaviours.rb"
        copy_file "empty_services_declaration.rb", "lib/patriarch/services.rb" 
      end
   
      def build_initializer
        create_file "config/initializers/patriarch.rb" do 
          "require 'patriarch'\n\n"+
          "load File.expand_path('../../../lib/patriarch/behaviours.rb', __FILE__)\n" + 
          "load File.expand_path('../../../lib/patriarch/services.rb', __FILE__)"
        end
      end
 
    end # InstallGenerator
  end # Generators
end # Patriarch
