class Patriarch::Services::<%= class_name %>::ManagerService < Patriarch::ManagerService
  # Return true or false
  def resolve(actor, target, medium, options={})
    
    # Flag initialized only if first add_step
    # It allows you to insert other behaviours into the callbacks without quitting the transaction
    # A like of an user on an item can trigger a subscribe to an item for instance 
    # It means it will rollback if follow is not performed correctly 

    if options[:transac]
      transac_first_step = false
    else
      transac_first_step = true
    end

    transac = options[:transac] || Patriarch::TransactionServices::TransactionManagerService.instance.new_transaction(:<%= class_name.underscore.to_sym %>)
    transac.add_step(:<%= class_name.underscore.to_sym %>,actor,target,medium)          

    callbacks_were_completed = false

    # Before logic not implemented yet here, to come in further releases
    if Patriarch::Services::<%= class_name %>::AuthorizationService.instance.grant?(transac)
      Patriarch::Services::<%= class_name %>::Service.instance.call(transac)
      if Patriarch::Services::<%= class_name %>::AfterManagerService.instance.resolve(transac)
        callbacks_were_completed = true
      end
    end

    # In some cases we want to interrupt the transaction before it executes and just play with
    # the transaction object  
    return transac if options[:stop_execution]

    # If everything went smoothly
    transac.execute if (transac_first_step && callbacks_were_completed)
  end

  def resolve_with_reduced_sql_database_calls(actor_class,actor_id,target_class,target_id,medium_class,medium_id)
    actor = OpenStruct.new ; actor.id = actor_id  
    actor.define_singleton_method(:class) do  
      actor_class
    end
    target = OpenStruct.new ; target.id = target_id ; target.class = target_class
    medium = OpenStruct.new ; medium.id = medium_id ; medium.class = medium_class
  end
end