class Patriarch::Services::<%= class_name %>::ManagerService < Patriarch::ManagerService
  # Return true or false
  def resolve(actor, target, options={})
    
    # Flag initialized only if first add_step
    # It allows you to insert other behaviours into the callbacks without quitting the transaction
    # A like of an user on an item can trigger a subscribe to an item for instance 
    # It means it will rollback if follow is not performed correctly 

    if options[:transac]
      transac_first_step = false
    else
      transac_first_step = true
    end

    transac = options[:transac] || Patriarch::TransactionServices::TransactionManagerService.instance.new_transaction(:<%= class_name.underscore.to_sym %>)
    transac.add_step(:<%= class_name.underscore.to_sym %>,actor,target)          

    callbacks_were_completed = false

    # Before logic not implemented yet here, to come in further releases
    if Patriarch::Services::<%= class_name %>::AuthorizationService.instance.grant?(transac)
      Patriarch::Services::<%= class_name %>::Service.instance.call(transac)
      if Patriarch::Services::<%= class_name %>::AfterManagerService.instance.resolve(transac)
        callbacks_were_completed = true
      end
    end

    # In some cases we want to interrupt the transaction before it executes and just play with
    # the transaction object  
    return transac if options[:stop_execution]

    # If everything went smoothly
    transac.execute if (transac_first_step && callbacks_were_completed)
  end
end
