require "patriarch/version"
require "redis"
require "redis/objects"
require "redis/objects/sorted_sets"
require "rails/generators"

# TODO remove this
# require File.expand_path('../generators/patriarch/behaviour_generator',__FILE__)

module Patriarch
	module Generators
    autoload :BehaviourGenerator,                   'generators/patriarch/behaviour_generator'
    autoload :InstallGenerator,                     'generators/patriarch/install_generator'
  end

  autoload :RedisInstruction,                       'patriarch/redis_instruction'  

  autoload :Service,																'patriarch/service'
	autoload :Transaction,														'patriarch/transaction'
	autoload :TransactionStep,                        'patriarch/transaction_step'
	autoload :AuthorizationService,										'patriarch/authorization_service'
	autoload :ManagerService,			 									  'patriarch/manager_service'
	autoload :Behaviours, 														'patriarch/behaviours'

  module DAOServices	
		autoload :BipartiteRelationshipBuilderService,  'patriarch/dao_services/bipartite_relationship_builder_service'
    autoload :TripartiteRelationshipBuilderService, 'patriarch/dao_services/tripartite_relationship_builder_service'    
		autoload :RedisMapperService,									  'patriarch/dao_services/redis_mapper_service'
		autoload :RetrieverService,											'patriarch/dao_services/retriever_service'
	end

	module ToolServices
		autoload :RedisCleanerService,									'patriarch/tool_services/redis_cleaner_service'
		autoload :RedisExtractorService,								'patriarch/tool_services/redis_extractor_service'	
	end

	module TransactionServices
		autoload :TransactionManagerService,						'patriarch/transaction_services/transaction_manager_service'		
	end

  def self.undo(str)
    undo = "undo_" 
    undo << str
    undo 
  end

end # Patriarch

require File.expand_path('../patriarch/behaviours',__FILE__)
